"use strict";

require("core-js/modules/es.array.concat");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withPlayroom = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactElementToJsxString = _interopRequireDefault(require("react-element-to-jsx-string"));

var _base64Url = _interopRequireDefault(require("base64-url"));

var _addons = require("@storybook/addons");

var _constants = require("./constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/* eslint-disable import/prefer-default-export */
var Story = function Story(_ref) {
  var getStory = _ref.getStory,
      context = _ref.context,
      _ref$settings$paramet = _ref.settings.parameters;
  _ref$settings$paramet = _ref$settings$paramet === void 0 ? {} : _ref$settings$paramet;
  var _ref$settings$paramet2 = _ref$settings$paramet.url,
      url = _ref$settings$paramet2 === void 0 ? 'http://localhost:9000' : _ref$settings$paramet2,
      _ref$settings$paramet3 = _ref$settings$paramet.disabled,
      disabled = _ref$settings$paramet3 === void 0 ? false : _ref$settings$paramet3;
  var story = getStory(context);
  var jsxString = (0, _reactElementToJsxString["default"])(story);

  var channel = _addons.addons.getChannel();

  var codeUrl = url && "".concat(url, "#?code=").concat(_base64Url["default"].encode(jsxString));
  channel.emit(_constants.EVENTS.UPDATE, codeUrl, disabled);
  return _react["default"].createElement(_react["default"].Fragment, null, story);
};

var withPlayroom = (0, _addons.makeDecorator)({
  name: 'withPlayroom',
  parameterName: 'playroom',
  allowDeprecatedUsage: true,
  wrapper: function wrapper(getStory, context, settings) {
    return _react["default"].createElement(Story, {
      getStory: getStory,
      context: context,
      settings: settings
    });
  }
});
exports.withPlayroom = withPlayroom;